require 'zookeeper'
require 'eventmachine'
require 'thin'
require 'zk'

require File.expand_path("../application",__FILE__)

class Zoo 
  #include EM::Deferrable
  def initialize
    @zk = ZK.new("localhost:2181")
    @path = "/rbtest"
    @server_found_base_path = "/xserver"
    #@
    puts "init succ #{@zk}"
  end
  
  # server found server part 
  # option temporarily has one param ip_port .eg "192.168.3.1:2222"
  def serverfound_server(option, child = 'default')
    #fork do
    # @zk.reopen()
     #end
    Thread.new{
      1000.times do
        re = @zk.create(@server_found_base_path + "/" + child, "192.168.2.2:#{rand(9999)}", :ephemeral => true, :sequence => true)
        puts "create ephemeral path #{re} "
        sleep(rand(10))
      end
    }
    Thread.new{
      1000.times do
        relist = @zk.children(@server_found_base_path)
        re = @zk.delete(@server_found_base_path+"/"+relist.pop) if !relist.empty?
        puts "delete ephemeral path #{re}"
        sleep(rand(9))
      end
    }
  end
  
  # server found client part 
  def serverfound_client(conetext, &block)
    puts "zk start watching on #{@server_found_base_path}"
    relist = @zk.children(@server_found_base_path, :watch => true)
    puts "get children #{relist} for the first time"
    
    context[:serverlist => relist]
    
    node_subscription = @zk.register(@server_found_base_path) do |event|
      puts "server found event is #{event}"
      if event.node_child?
        # get children and re-set watch 
        relist = @zk.children(@server_found_base_path, :watch => true)
        puts relist
      end
    end
    # register watch (won't work!!!)
    #@zk.stat(@server_found_base_path, watch: true)
  end
  
  def run 
    #p @zk.methods.sort
    #@queue.pop
    #p "lalala #{@queue}"

    @zk.create(@path, "data", :sequence => true, :ephemeral => true)

    node_subscription = @zk.register(@path) do |event|
      p event
      #p event.methods.sort
      if event.node_deleted?
        p ''
      end
      
      # re-register 
      @zk.stat(@path, :watch => true)
    end
    
    @zk.stat(@path, :watch => true)
  end
end

#EM.run do
  #EM.schedule do
    zoo = Zoo.new
    #if $zdo == '1'
    rand(3).times do
      zoo.serverfound_server(:ip_port => "192.168.2.2:#{rand(9999)}")
    end
    zoo.serverfound_server(:ip_port => nil)
    #end
    #if $zdo == '2'
      #zoo.serverfound_client
    #end
 # end
#end
sleep(1000000)
